const express = require("express");
const xss     = require("xss-filters");
const router  = express.Router();
const utils   = require("../../Utils");
const bcrypt  = require("bcryptjs");

router.get('/', (req, res) => {

  res.json({
    message: 'hello'
  })

})

router.post('/login', (req, res) => {

  const username = xss.inHTMLData(req.body.username),
        password = xss.inHTMLData(req.body.password);
  var userid, thrown = false;

  utils.db.query("SELECT * FROM users WHERE username = ?", [username])
    .then(row => {

      if(row.length == 0){
        res.status(403).json({error: 'Credenziali invalide'});
        thrown = true;
        throw new Error('invalid_credentials');
      }

      var hash = row[0].password;
      userid = row[0].userid;
      return bcrypt.compare(password, hash)

    })

    .then(async(success) => {

      if(!success){
        if(row.length == 0){
          res.status(403).json({error: 'Credenziali invalide'});
          thrown = true;
          throw new Error('invalid_credentials');
        }
      }

      var sessionid = await utils.generateSession(userid);
      res.cookie('sid', sessionid, {path: '/', maxAge: 900000000, httpOnly: true, secure: true, domain: 'silvia.emilianomaccaferri.com'});
      res.json({success: true});

    })

    .catch(err => {

      if(thrown)
        return;

      if(!utils.isValidJSON(err));
        err = {error: 'fatal', status: 500};

      res.status(err.status || 500).json(err);

    })

  //res.cookie('sessionid', sessionid, {path: '/', maxAge: 900000000, httpOnly: true, secure: true, domain: 'social.emilianomaccaferri.com'});

})

module.exports = router;
